/*
errcodes.h
*/
#ifndef __ERRCODES_H__
#define __ERRCODES_H__ 1
#ifdef  __cplusplus
extern "C" {
#endif

#define COMMAND_ERROR_SUCCESS 0
#define COMMAND_ERROR_MEMORY_LOW 1
#define COMMAND_ERROR_NOARRAY 2
#define COMMAND_ERROR_DIV 3
#define COMMAND_ERROR_UNDEFOP 4
#define COMMAND_ERROR_BAD_CALL 5
#define COMMAND_ERROR_FEW_ARGS 6
#define COMMAND_ERROR_ARGUMENT_TYPE 7
#define COMMAND_ERROR_ARGUMENT_RANGE 8
#define COMMAND_ERROR_FILE_READ 9
#define COMMAND_ERROR_FILE_WRITE 10
#define COMMAND_ERROR_FILE 11
#define COMMAND_ERROR_CIRCULAR 12
#define COMMAND_ERROR_MODULE_NOT_LOADED 13
#define COMMAND_ERROR_PARTIAL_UNLOAD 14
#define COMMAND_ERROR_MODULE_ACTIVE 15
#define COMMAND_ERROR_MODULE_LOAD 16
#define COMMAND_ERROR_MODULE_FUNCTION 17
#define COMMAND_ERROR_MODULE_INITIALIZE 18
#define COMMAND_ERROR_MODULE_VERSION 19
#define COMMAND_ERROR_BAD_FILE_NUMBER 20
#define COMMAND_ERROR_FILE_NUMBER_IS_USED 21
#define COMMAND_ERROR_FILE_CANNOT_BE_OPENED 22
#define COMMAND_ERROR_FILE_IS_NOT_OPENED 23
#define COMMAND_ERROR_INVALID_LOCK 24
#define COMMAND_ERROR_PRINT_FAIL 25
#define COMMAND_ERROR_MKDIR_FAIL 26
#define COMMAND_ERROR_DELETE_FAIL 27
#define COMMAND_ERROR_NOTIMP 28
#define COMMAND_ERROR_INVALID_JOKER 29
#define COMMAND_ERROR_NO_RESUME 30
#define COMMAND_ERROR_INV_DNAME 31
#define COMMAND_ERROR_INV_DO_OPTION 32
#define COMMAND_ERROR_DIR_NO_OPEN 33
#define COMMAND_ERROR_BAD_RECORD_LENGTH 34
#define COMMAND_ERROR_CURDIR 35
#define COMMAND_ERROR_UNDEF_DIR 36
#define COMMAND_ERROR_CHDIR 37
#define COMMAND_ERROR_RETURN_WITHOUT_GOSUB 38
#define COMMAND_ERROR_INVALID_ARGUMENT_FOR_FUNCTION_ADDRESS 39
#define COMMAND_ERROR_SETFILE_INVALID_ATTRIBUTE 40
#define COMMAND_ERROR_CHOWN_INVALID_USER 41
#define COMMAND_ERROR_CHOWN_NOT_SUPPORTED 42
#define COMMAND_ERROR_CHOWN_SET_OWNER 43
#define COMMAND_ERROR_INVALID_FILE_NAME 44
#define COMMAND_ERROR_CREATIME_FAIL 45
#define COMMAND_ERROR_MODTIME_FAIL 46
#define COMMAND_ERROR_ACCTIM_FAIL 47
#define COMMAND_ERROR_INVALID_TIME_FORMAT 48
#define COMMAND_ERROR_INVALID_TIME 49
#define COMMAND_ERROR_EXTENSION_SPECIFIC 50
#define COMMAND_ERROR_SOCKET_FILE 51
#define COMMAND_ERROR_INVALID_CODE 52
#define COMMAND_ERROR_MANDARG 53
#define COMMAND_ERROR_TIMEOUT 54
#define COMMAND_ERROR_STAYS_IN_MEMORY 55
#define COMMAND_ERROR_PREPROCESSOR_ABORT 56
#define COMMAND_ERROR_NOTSTARTED 134

#define BU_ERROR_SUCCESS 0
#define BU_ERROR_MEMORY_LOW 1
#define BU_ERROR_FILE_CORRUPT 57
#define BU_ERROR_NO_CODE 58
#define BU_ERROR_FAIL 59
#define BU_ERROR_ECODE_INPUT 60
#define READER_ERROR_SUCCESS 0
#define READER_ERROR_MEMORY_LOW 1
#define READER_ERROR_INCLUDE_SYNTAX 61
#define READER_ERROR_INCLUDE_FILE 62
#define READER_ERROR_TOOMANY_INCLUDE 63
#define READER_ERROR_PREPROC_UNDEF 64
#define READER_ERROR_PREPROC_LONG 65
#define READER_ERROR_PREPROC_NOTAVA 66
#define READER_ERROR_PREPROC_NOTVAL 67
#define READER_ERROR_FILE_OPEN 68
#define READER_ERROR_EMPTY_INPUT 69
#define PREPROC_ERROR_SUCCESS 0
#define PREPROC_ERROR_MEMORY_LOW 1
#define PREPROC_ERROR_FAIL 70
#define PREPROC_ERROR_CONFIG_EXE 71
#define PREPROC_ERROR_CONFIG_DIR 72
#define LEX_ERROR_SUCCESS 0
#define LEX_ERROR_MEMORY_LOW 1
#define LEX_ERROR_TOO_LONG_SYMBOL 73
#define LEX_ERROR_STRING_NOT_TERMINATED 74
#define LEX_ERROR_STRING_NEW_LINE 75
#define LEX_ERROR_BAD_RADIX 76
#define LEX_ERROR_INVALID_NUMBER 77
#define EXE_ERROR_SUCCESS 0
#define EXE_ERROR_MEMORY_LOW 1
#define EXE_ERROR_INVALID_PC 78
#define EXE_ERROR_INVALID_PC1 79
#define EXE_ERROR_INVALID_NODE 80
#define EXE_ERROR_INVALID_OPCODE 81
#define EXE_ERROR_NOT_IMPLEMENTED 82
#define EXE_ERROR_INVALID_EXPRESSION_NODE 83
#define EXE_ERROR_INVALID_EXPRESSION_NODE1 84
#define EXE_ERROR_INTERNAL_DEFAULTTYPE 85
#define EXE_ERROR_INTERNAL_UNDEF 86
#define EXE_ERROR_INTERNAL_MEMREF 87
#define EXE_ERROR_INTERNAL 88
#define EXE_ERROR_NO_LOCAL 89
#define EXE_ERROR_INVALID_LVALNODE0 90
#define EXE_ERROR_INVALID_LVALNODE1 91
#define EXE_ERROR_INVALID_LVALNODE2 92
#define EXE_ERROR_INVALID_LVALNODE3 93
#define EXE_ERROR_INVALID_LVALNODE4 94
#define EXE_ERROR_INVALID_LVALNODE5 95
#define EXE_ERROR_INVALID_LVALNODE6 96
#define EXE_ERROR_USERFUN_UNDEFINED 97
#define EXE_ERROR_TOO_DEEP_CALL 98
#define EXE_ERROR_TOO_LONG_RUN 99
#define EX_ERROR_SUCCESS 0
#define EX_ERROR_MEMORY_LOW 1
#define EX_ERROR_INTERNAL 100
#define EX_ERROR_LABEL_DOUBLE_DEFINED 101
#define EX_ERROR_LABEL_NOT_DEFINED 102
#define EX_ERROR_FUNCTION_DOUBLE_DEFINED 103
#define EX_ERROR_FUNCTION_NOT_DEFINED 104
#define EX_ERROR_NO_OLD_NAMESPACE 105
#define EX_ERROR_UNFINISHED_MODULE 106
#define EX_ERROR_TOO_LONG_NAME_SPACE 107
#define EX_ERROR_TOO_LONG_VARIABLE 108
#define EX_ERROR_MISSING_PAREN 109
#define EX_ERROR_MISSING_OPAREN 110
#define EX_ERROR_MISSING_APAREN 111
#define EX_ERROR_MISSING_SAPAREN 112
#define EX_ERROR_FUNCTION_NEEDS_ARGUMENTS 113
#define EX_ERROR_TOO_FEW_ARGUMENTS 114
#define EX_ERROR_TOO_MANY_ARGUMENTS 115
#define EX_ERROR_BAD_NESTING 116
#define EX_ERROR_UNFINISHED_NESTING 117
#define EX_ERROR_SYNTAX 118
#define EX_ERROR_SYNTAX_FATAL 119
#define EX_ERROR_TOO_MANY_WAITING_LABEL 120
#define EX_ERROR_UNDEF_GLOBAL 121
#define EX_ERROR_UNDEF_PRAGMA 122
#define EX_ERROR_GREDEF 123
#define EX_ERROR_GLODEF 124
#define EX_ERROR_CONST_LVAL 125
#define MEM_ERROR_SUCCESS 0
#define MEM_ERROR_MEMORY_LOW 1
#define MEM_ERROR_INTERNAL001 126
#define MATCH_ERROR_SUCCESS 0
#define MATCH_ERROR_MEMORY_LOW 1
#define MATCH_ERROR_INDEX_OUT_OF_RANGE 127
#define MATCH_ERROR_BUFFER_SHORT 128
#define MATCH_ERROR_SYNTAX_ERROR 129
#define MATCH_ERROR_ARRAY_SHORT 130
#define CONFIG_ERROR_SUCCESS 0
#define CONFIG_ERROR_MEMORY_LOW 1
#define SCRIBA_ERROR_SUCCESS 0
#define SCRIBA_ERROR_MEMORY_LOW 1
#define SCRIBA_ERROR_FAIL 131
#define SCRIBA_ERROR_BUFFER_SHORT 132
#define MAX_ERROR_CODE 133
typedef struct { char *language; char **array; } tErrorMessageArray;
extern tErrorMessageArray ErrorMessageArray[];
extern char  *en_error_messages[];
#ifdef __cplusplus
}
#endif
#endif
